/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreStudy.TCoreStudyPath;
import de.ship.db.tables.records.TDmTransferRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmTransfer extends TableImpl<TDmTransferRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_transfer</code>
     */
    public static final TDmTransfer T_DM_TRANSFER = new TDmTransfer();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmTransferRecord> getRecordType() {
        return TDmTransferRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_transfer.lastchange</code>.
     */
    public final TableField<TDmTransferRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_transfer.pk</code>.
     */
    public final TableField<TDmTransferRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_dm_transfer.study</code>. foreign key to
     * study id
     */
    public final TableField<TDmTransferRecord, Integer> STUDY = createField(DSL.name("study"), SQLDataType.INTEGER.nullable(false), this, "foreign key to study id");

    /**
     * The column <code>common_dd.t_dm_transfer.additive</code>.
     */
    public final TableField<TDmTransferRecord, Integer> ADDITIVE = createField(DSL.name("additive"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_dm_transfer.varname_old</code>. name of old
     * variable
     */
    public final TableField<TDmTransferRecord, String> VARNAME_OLD = createField(DSL.name("varname_old"), SQLDataType.CLOB.nullable(false), this, "name of old variable");

    /**
     * The column <code>common_dd.t_dm_transfer.varname_new</code>. name of new
     * / additive variable
     */
    public final TableField<TDmTransferRecord, String> VARNAME_NEW = createField(DSL.name("varname_new"), SQLDataType.CLOB, this, "name of new / additive variable");

    private TDmTransfer(Name alias, Table<TDmTransferRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmTransfer(Name alias, Table<TDmTransferRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_transfer</code> table reference
     */
    public TDmTransfer(String alias) {
        this(DSL.name(alias), T_DM_TRANSFER);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_transfer</code> table reference
     */
    public TDmTransfer(Name alias) {
        this(alias, T_DM_TRANSFER);
    }

    /**
     * Create a <code>common_dd.t_dm_transfer</code> table reference
     */
    public TDmTransfer() {
        this(DSL.name("t_dm_transfer"), null);
    }

    public <O extends Record> TDmTransfer(Table<O> path, ForeignKey<O, TDmTransferRecord> childPath, InverseForeignKey<O, TDmTransferRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_TRANSFER);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmTransferPath extends TDmTransfer implements Path<TDmTransferRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmTransferPath(Table<O> path, ForeignKey<O, TDmTransferRecord> childPath, InverseForeignKey<O, TDmTransferRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmTransferPath(Name alias, Table<TDmTransferRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmTransferPath as(String alias) {
            return new TDmTransferPath(DSL.name(alias), this);
        }

        @Override
        public TDmTransferPath as(Name alias) {
            return new TDmTransferPath(alias, this);
        }

        @Override
        public TDmTransferPath as(Table<?> alias) {
            return new TDmTransferPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmTransferRecord, Integer> getIdentity() {
        return (Identity<TDmTransferRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmTransferRecord> getPrimaryKey() {
        return Keys.PK_DM_TRANSFER;
    }

    @Override
    public List<UniqueKey<TDmTransferRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_DM_TRANSFER);
    }

    @Override
    public List<ForeignKey<TDmTransferRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_TRANSFER__FK_DM_TRANSFER_STUDY);
    }

    private transient TCoreStudyPath _tCoreStudy;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_study</code>
     * table.
     */
    public TCoreStudyPath tCoreStudy() {
        if (_tCoreStudy == null)
            _tCoreStudy = new TCoreStudyPath(this, Keys.T_DM_TRANSFER__FK_DM_TRANSFER_STUDY, null);

        return _tCoreStudy;
    }

    @Override
    public TDmTransfer as(String alias) {
        return new TDmTransfer(DSL.name(alias), this);
    }

    @Override
    public TDmTransfer as(Name alias) {
        return new TDmTransfer(alias, this);
    }

    @Override
    public TDmTransfer as(Table<?> alias) {
        return new TDmTransfer(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTransfer rename(String name) {
        return new TDmTransfer(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTransfer rename(Name name) {
        return new TDmTransfer(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTransfer rename(Table<?> name) {
        return new TDmTransfer(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTransfer where(Condition condition) {
        return new TDmTransfer(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTransfer where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTransfer where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTransfer where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTransfer where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTransfer where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTransfer where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTransfer where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTransfer whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTransfer whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
